﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_treeview_yield_checked
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            trvMeals.ExpandAll();
        }

        // List the checked TreeNodes.
        private void btnShowChecked_Click(object sender, EventArgs e)
        {
            string results = "";
            foreach (TreeNode node in CheckedNodes(trvMeals))
                results += node.Text + "\n";
            MessageBox.Show(results);
        }

        // Return a list of the checked TreeView nodes.
        private IEnumerable<TreeNode> CheckedNodes(TreeView trv)
        {
            return CheckedNodes(trv.Nodes);
        }

        // Return a list of the TreeNodes that are checked.
        private IEnumerable<TreeNode> CheckedNodes(TreeNodeCollection nodes)
        {
            foreach (TreeNode node in nodes)
            {
                // Yield this node.
                if (node.Checked) yield return node;

                // Yield the checked descendants of this node.
                foreach (TreeNode checked_child in CheckedNodes(node.Nodes))
                    yield return checked_child;
            }
        }
    }
}
